﻿using System.Security.Cryptography.X509Certificates;
using FitConnect;
using FitConnect.Models;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Logging.Abstractions;

ILogger _logger;
Client client;
X509Certificate2 certificate;

var destinationId = "aa3704d6-8bd7-4d40-a8af-501851f93934";
var leikaKey = "urn:de:fim:leika:leistung:99400048079000";
var clientSecret = "rdlXms-4ikO47AbTmmCTdzFoE4cTSt13JmSbcY5Dhsw";
var clientId = "73a8ff88-076b-4263-9a80-8ebadac97b0d";

void FluentSenderCall() {
    
    new Client(
            FitConnectEndpoints.Create(FitConnectEndpoints.EndpointType.Development),
            clientId, clientSecret,
            logger: _logger).GetSender()
        .WithDestination(destinationId)
        .WithServiceType("ServiceName", leikaKey)
        .WithAttachments(new List<Attachment>() {
            new Attachment {
                Id = Guid.NewGuid().ToString(),
                Content = File.ReadAllBytes("Test.pdf"),
                MimeType = "application/pdf",
                Description = "The description of the attachment",
                Purpose = "attachment"
            }
        })
        .WithData("{\"data\":\"value\"}")
        .Submit();
}

void FluentSubscriberCall() {
    var submissions = client.GetSubscriber("", "")
        .GetAvailableSubmissions();

    client.GetSubscriber("", "").RequestSubmission("submissionId")
        .GetAttachments(attachments => {
            // Check if the attachments are valid
            return true;
        });
}

_logger = LoggerFactory.Create(
    builder => {
        builder.AddSimpleConsole();
        builder.SetMinimumLevel(LogLevel.Information);
    }).CreateLogger("FluentSenderTests");

_logger.Log(LogLevel.Information,
    "This is a dummy client to demonstrate the usage of the FIT-Connect SDK for .NET");


client = new Client(
    FitConnectEndpoints.Create(FitConnectEndpoints.EndpointType.Development),
    clientId, clientSecret,
    logger: _logger);

Console.WriteLine(
    "This is a dummy client to demonstrate the usage of the FIT-Connect SDK for .NET");

FluentSenderCall();
// FluentSubscriberCall();
